/*
  grob-info.hh -- declare Grob_info

  source file of the GNU LilyPond music typesetter

  (c) 1997--2005 Han-Wen Nienhuys <hanwen@cs.uu.nl>
*/

#ifndef STAFFELEMINFO_HH
#define STAFFELEMINFO_HH

#include "lily-guile.hh"
#include "lily-proto.hh"
#include "parray.hh"

/*
  Data container for broadcasts.
*/
class Grob_info
{
  Translator *origin_trans_;
  friend class Engraver;
  Grob *grob_;

public:
  Grob *grob () const { return grob_; }
  Translator *origin_translator () const { return origin_trans_; } 

  Context *context () const; 
  Music *music_cause ();
  Link_array<Context> origin_contexts (Translator *) const;
  Grob_info (Translator *, Grob *);
  Grob_info ();
};

#endif // STAFFELEMINFO_HH
